# coding: utf-8

"""
Copyright 2016 SmartBear Software

    Licensed under the Apache License, Version 2.0 (the "License");
    you may not use this file except in compliance with the License.
    You may obtain a copy of the License at

        http://www.apache.org/licenses/LICENSE-2.0

    Unless required by applicable law or agreed to in writing, software
    distributed under the License is distributed on an "AS IS" BASIS,
    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
    See the License for the specific language governing permissions and
    limitations under the License.

    Ref: https://github.com/swagger-api/swagger-codegen
"""

from pprint import pformat
from six import iteritems
import re


class CloudPoolExtended(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self):
        """
        CloudPoolExtended - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'accounts': 'list[str]',
            'description': 'str',
            'name': 'str',
            'vendor': 'str',
            'id': 'str',
            'type': 'str'
        }

        self.attribute_map = {
            'accounts': 'accounts',
            'description': 'description',
            'name': 'name',
            'vendor': 'vendor',
            'id': 'id',
            'type': 'type'
        }

        self._accounts = None
        self._description = None
        self._name = None
        self._vendor = None
        self._id = None
        self._type = None

    @property
    def accounts(self):
        """
        Gets the accounts of this CloudPoolExtended.
        A list of valid names for the accounts in this pool

        :return: The accounts of this CloudPoolExtended.
        :rtype: list[str]
        """
        return self._accounts

    @accounts.setter
    def accounts(self, accounts):
        """
        Sets the accounts of this CloudPoolExtended.
        A list of valid names for the accounts in this pool

        :param accounts: The accounts of this CloudPoolExtended.
        :type: list[str]
        """
        
        self._accounts = accounts

    @property
    def description(self):
        """
        Gets the description of this CloudPoolExtended.
        A brief description of this pool

        :return: The description of this CloudPoolExtended.
        :rtype: str
        """
        return self._description

    @description.setter
    def description(self, description):
        """
        Sets the description of this CloudPoolExtended.
        A brief description of this pool

        :param description: The description of this CloudPoolExtended.
        :type: str
        """
        
        self._description = description

    @property
    def name(self):
        """
        Gets the name of this CloudPoolExtended.
        A unique name for this pool

        :return: The name of this CloudPoolExtended.
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """
        Sets the name of this CloudPoolExtended.
        A unique name for this pool

        :param name: The name of this CloudPoolExtended.
        :type: str
        """
        
        self._name = name

    @property
    def vendor(self):
        """
        Gets the vendor of this CloudPoolExtended.
        A string identifier of the cloud services vendor

        :return: The vendor of this CloudPoolExtended.
        :rtype: str
        """
        return self._vendor

    @vendor.setter
    def vendor(self, vendor):
        """
        Sets the vendor of this CloudPoolExtended.
        A string identifier of the cloud services vendor

        :param vendor: The vendor of this CloudPoolExtended.
        :type: str
        """
        
        self._vendor = vendor

    @property
    def id(self):
        """
        Gets the id of this CloudPoolExtended.
        A unique name for this pool

        :return: The id of this CloudPoolExtended.
        :rtype: str
        """
        return self._id

    @id.setter
    def id(self, id):
        """
        Sets the id of this CloudPoolExtended.
        A unique name for this pool

        :param id: The id of this CloudPoolExtended.
        :type: str
        """
        
        self._id = id

    @property
    def type(self):
        """
        Gets the type of this CloudPoolExtended.
        The type of cloud protocol required (e.g., 'ran', 'azure')

        :return: The type of this CloudPoolExtended.
        :rtype: str
        """
        return self._type

    @type.setter
    def type(self, type):
        """
        Sets the type of this CloudPoolExtended.
        The type of cloud protocol required (e.g., 'ran', 'azure')

        :param type: The type of this CloudPoolExtended.
        :type: str
        """
        allowed_values = ["ran", "azure"]
        if type is not None and type not in allowed_values:
            raise ValueError(
                "Invalid value for `type`, must be one of {0}"
                .format(allowed_values)
            )

        self._type = type

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other

